<template>
  <div>
    <BasicTable @register="registerTable">
      <template #toolbar>
        <a-button preIcon="OutR|svg" ghost color="success" @click="aoaToExcel"> 导出 </a-button>
      </template>
      <!-- <template #action="{ record }">
        <TableAction
          :actions="[
            {
              icon: 'clarity:note-edit-line',
              onClick: handleEdit.bind(null, record),
            },
            {
              icon: 'ant-design:delete-outlined',
              color: 'error',
              popConfirm: {
                title: '是否确认删除?',
              placement: 'left',
                confirm: handleDelete.bind(null, record),
              },
            },
          ]"
        />
      </template> -->
    </BasicTable>
    <Loading :loading="compState.loading" :tip="compState.tip" />
    <!-- <WmsItemDrawer @register="registerDrawer" @success="handleSuccess" /> -->
  </div>
</template>
<script lang="ts" setup>

import { aoaToSheetXlsx } from '/@/components/Excel';

import { reactive } from 'vue';

import { BasicTable, useTable } from '/@/components/Table';

import { columns, searchFormSchema } from './wms_item.data';
import { getWmsItemHisListByPage } from '/@/api/tigerapi/wms/wms_item_his';

import { useTabs } from '/@/hooks/web/useTabs';
import { Loading } from '/@/components/Loading';
import { useMessage } from '/@/hooks/web/useMessage';
import { useI18n } from '/@/hooks/web/useI18n';

const { t } = useI18n();
const { createMessage } = useMessage();

const compState = reactive({
  absolute: false,
  loading: false,
  tip: '加载中...',
});
const [registerTable, { reload, getForm, getPaginationRef }] = useTable({
  title: '追溯查询',
  api: getWmsItemHisListByPage,
  columns,
  formConfig: {
    labelWidth: 120,
    schemas: searchFormSchema,
  },
  useSearchForm: true,

  showTableSetting: true,
  // canColDrag:true,
  ellipsis: true,
  //canResize:true,

  bordered: true,
  showIndexColumn: false,
  // actionColumn: {
  //   width: 80,
  //   title: '操作',
  //   dataIndex: 'action',
  //   slots: { customRender: 'action' },
  //   fixed: undefined,
  // },
});
const { setTitle } = useTabs();
//setTitle('实时库存' + (ItemCode.value==''?'':',料号：('+ItemCode.value+')'));

function handleSuccess() {
  reload();
}

let arr: any[] = [];
function aoaToExcel() {
  const totals = getPaginationRef().total
  if (totals < 30000) {
    arr = [];
    compState.loading = true;
    const col = getForm().getFieldsValue()
    const data = getWmsItemHisListByPage(col).then((res) => {
      res.items.forEach(element => {

        let result = ''
        switch (element.STATUS) {
          case 0:
            result = '不存在';
            break;
          case 10:
            result = '送货中';
            break;
          case 20:
            result = '待检验';
            break;
          case 30:
            result = '待入库';
            break;
          case 40:
            result = '在库中';
            break;
          case 50:
            result = '已下架';
            break;
          case 60:
            result = '已发料';
            break;
          case 70:
            result = '已上料';
            break;
          case 80:
            result = '已耗尽';
            break;
          case 90:
            result = '已退料';
            break;
          case 100:
            result = '已发货';
            break;
          default:
            break;
        }
        arr.push({
          '单据代码': element.TRANS_NO,
          '条码': element.SN,
          '物料代码': element.ITEM_CODE,
          '条码来源说明': element.TRACE_INFO,
          '数量': element.QTY,
          '原始箱号': element.CARTON_NO,
          '操作时间': element.CREATE_TIME,
          '储存状态': result,
          '仓库': element.WH_CODE,
          '储位': element.LOCATION_CODE,
          '单位': element.UNIT,
          '生产日期': element.PROD_DATE,
          '首次入库日期': element.FIRST_IN_DATE,
          '单据行号': element.TRANS_LINE,
          '供应商代码': element.SUPP_CODE,
          '供应商批次号': element.SUPP_LOTNO,
          '批次号': element.LOTNO,
          '箱号': element.CARTON_NO,
          '栈板号': element.PALLET_NO,
          '更新人': element.UPDATE_USER,
        });
      });
      const arrHeader = columns.map((column) => column.title);
      const arrData = arr.map((item) => {
        return Object.keys(item).map((key) => item[key]);
      });
      // 保证data顺序与header一致
      if(arr.length<30000){
        aoaToSheetXlsx({
        data: arrData,
        header: arrHeader,
        filename: '追溯报表.xlsx',
      });
      }else{
        createMessage.error(t('导出数据不能超过三万条，如需要更多的请联系管理员'));
      }
      
      compState.loading = false;

    })

  } else {
    createMessage.error(t('导出数据不能超过三万条，如需要更多的请联系管理员'));
  }


}
</script>
